'use strict';var juju={components:{}},testUtils=React.addons.TestUtils;chai.config.includeStack=!0,chai.config.truncateThreshold=0,describe('Configuration',function(){var a;beforeAll(function(b){YUI().use('inspector-config',function(){b()})}),beforeEach(()=>{a={isReadOnly:sinon.stub().returns(!1)}}),it('renders binary and string config inputs',function(){var b={key:'option1key',type:'string'},c={key:'option2key',type:'boolean'};const d=sinon.stub();d.onCall(0).returns('description 1'),d.onCall(1).returns('description 2');var e='string body value',f=!0,i=sinon.stub();const j=jsTestUtils.shallowRender(React.createElement(juju.components.Configuration,{acl:a,addNotification:sinon.stub(),changeState:sinon.stub(),charm:{get:function(){return{option1:b,option2:c}}},getServiceByName:sinon.stub(),getYAMLConfig:sinon.stub(),linkify:d,service:{get:function(m){return'id'===m?'abc123':{option1:e,option2:f}}},serviceRelations:[],setConfig:i,unplaceServiceUnits:sinon.stub(),updateServiceUnitsDisplayname:sinon.stub()}),!0),k=j.getMountedInstance(),l=j.getRenderOutput();expect(l.props.children[0].props.children[4][0]).toEqualJSX(React.createElement(juju.components.StringConfig,{key:'Config-option1',ref:'Config-option1',onChange:k._handleOnChange,option:{description:'description 1',key:'option1',type:'string'},config:e})),expect(l.props.children[0].props.children[4][1]).toEqualJSX(React.createElement(juju.components.BooleanConfig,{key:'Config-option2',ref:'Config-option2',label:'option2:',onChange:k._handleOnChange,option:{description:'description 2',key:'option2',type:'boolean'},config:f}))}),it('renders message when no config available',function(){var d=jsTestUtils.shallowRender(React.createElement(juju.components.Configuration,{acl:a,addNotification:sinon.stub(),changeState:sinon.stub(),charm:{get:function(){return null}},getServiceByName:sinon.stub(),getYAMLConfig:sinon.stub(),linkify:sinon.stub(),service:{get:function(e){return'id'===e?'abc123':{}}},serviceRelations:[],setConfig:sinon.stub(),unplaceServiceUnits:sinon.stub(),updateServiceUnitsDisplayname:sinon.stub()}));expect(d.props.children[0].props.children[4]).toEqualJSX(React.createElement('div',{className:'inspector-config--no-config'},'No configuration options.'))}),it('saves the config when save config is clicked',function(){var b={key:'option1key',type:'string'},c={key:'option2key',type:'boolean'},g=sinon.stub();g.withArgs('id').returns('cs:trusty/ghost'),g.withArgs('config').returns({option1:'string body value',option2:!0});var i=sinon.stub(),j=sinon.stub(),k=testUtils.renderIntoDocument(React.createElement(juju.components.Configuration,{acl:a,addNotification:sinon.stub(),changeState:j,charm:{get:function(){return{option1:b,option2:c}}},getServiceByName:sinon.stub(),getYAMLConfig:sinon.stub(),linkify:sinon.stub(),service:{get:g},serviceRelations:[],setConfig:i,unplaceServiceUnits:sinon.stub(),updateServiceUnitsDisplayname:sinon.stub()})),l=ReactDOM.findDOMNode(k),m=l.querySelector('.string-config-input'),n=l.querySelector('.boolean-config--input');m.innerText='new value',testUtils.Simulate.input(m),testUtils.Simulate.change(n,{target:{checked:!1}});var o=l.querySelector('.button-row--count-2 .button--neutral');testUtils.Simulate.click(o),assert.equal(i.callCount,1);var p=i.args[0];assert.strictEqual(p.length,3),assert.equal(p[0],'cs:trusty/ghost'),assert.deepEqual(p[1],{option1:'new value',option2:!1}),assert.equal(j.callCount,1),assert.deepEqual(j.args[0][0],{gui:{inspector:{id:'cs:trusty/ghost',activeComponent:void 0}}})}),it('can change the service name for ghost services',function(){var d={get:sinon.stub().returns({option1:{key:'option1key',type:'string'},option2:{key:'option2key',type:'boolean'}})},g=sinon.stub();g.withArgs('id').returns('abc123$'),g.withArgs('name').returns('servicename'),g.withArgs('config').returns({option1:'string body value',option2:!0});var h={get:g,set:sinon.stub()},i=sinon.stub(),j=sinon.stub().returns(null),k=testUtils.renderIntoDocument(React.createElement(juju.components.Configuration,{acl:a,addNotification:sinon.stub(),changeState:sinon.stub(),charm:d,getServiceByName:j,getYAMLConfig:sinon.stub(),linkify:sinon.stub(),service:h,serviceRelations:[],setConfig:sinon.stub(),unplaceServiceUnits:sinon.stub(),updateServiceUnitsDisplayname:i}));assert.equal(k.refs.ServiceName.props.config,'servicename');var l=ReactDOM.findDOMNode(k),m=l.querySelector('.string-config-input');m.innerText='newservicename',testUtils.Simulate.input(m);var n=l.querySelector('.button-row--count-2 .button--neutral');testUtils.Simulate.click(n),assert.equal(h.set.callCount,1),assert.deepEqual(h.set.args[0],['name','newservicename']),assert.equal(i.callCount,1),assert.equal(i.args[0][0],'abc123$'),assert.equal(j.callCount,1),assert.equal(j.args[0][0],'newservicename')}),it('allows you to modify the series of multi-series charms',function(){var b={key:'option1key',type:'string'},f=sinon.stub(),g=jsTestUtils.shallowRender(React.createElement(juju.components.Configuration,{acl:a,addNotification:sinon.stub(),changeState:sinon.stub(),charm:{get:function(k){return'options'===k?{option1:b}:'series'===k?['precise','trusty']:void 0}},getServiceByName:sinon.stub(),getYAMLConfig:sinon.stub(),linkify:sinon.stub(),service:{get:function(k){return'id'===k?'abc123':'series'===k?'trusty':!('pending'!==k)||{option1:'string body value'}}},serviceRelations:[],setConfig:f,unplaceServiceUnits:sinon.stub(),updateServiceUnitsDisplayname:sinon.stub()}),!0),h=g.getRenderOutput(),i=g.getMountedInstance(),j=React.createElement('div',{className:'inspector-config__series-select'},React.createElement('span',null,'Choose Series'),React.createElement('select',{className:'inspector-config__select',disabled:!1,onChange:i._handleSeriesChange,title:void 0,value:'trusty'},[React.createElement('option',{key:'precise',value:'precise'},'precise'),React.createElement('option',{key:'trusty',value:'trusty'},'trusty')]),React.createElement('span',{className:'inspector-config__series-select-description'},'Choose the series to deploy. This cannot be changed once the application is deployed.'));expect(h.props.children[0].props.children[1]).toEqualJSX(j)}),it('disables the series select if there are existing relations',function(){var b={key:'option1key',type:'string'},f=sinon.stub(),g=jsTestUtils.shallowRender(React.createElement(juju.components.Configuration,{acl:a,addNotification:sinon.stub(),changeState:sinon.stub(),charm:{get:function(k){return'options'===k?{option1:b}:'series'===k?['precise','trusty']:void 0}},getServiceByName:sinon.stub(),getYAMLConfig:sinon.stub(),linkify:sinon.stub(),service:{get:function(k){return'id'===k?'abc123':'series'===k?'trusty':!('pending'!==k)||{option1:'string body value'}}},serviceRelations:['one'],setConfig:f,unplaceServiceUnits:sinon.stub(),updateServiceUnitsDisplayname:sinon.stub()}),!0),h=g.getRenderOutput(),i=g.getMountedInstance(),j=React.createElement('div',{className:'inspector-config__series-select'},React.createElement('span',null,'Choose Series'),React.createElement('select',{className:'inspector-config__select',disabled:!0,onChange:i._handleSeriesChange,title:'The series for this subordinate has been set to the application it is related to.',value:'trusty'},[React.createElement('option',{key:'precise',value:'precise'},'precise'),React.createElement('option',{key:'trusty',value:'trusty'},'trusty')]),React.createElement('span',{className:'inspector-config__series-select-description'},'Choose the series to deploy. This cannot be changed once the application is deployed.'));expect(h.props.children[0].props.children[1]).toEqualJSX(j)}),it('does not allow you to change series if app is deployed',function(){var b={key:'option1key',type:'string'},f=jsTestUtils.shallowRender(React.createElement(juju.components.Configuration,{acl:a,addNotification:sinon.stub(),changeState:sinon.stub(),charm:{get:function(g){return'options'===g?{option1:b}:'series'===g?['precise','trusty']:void 0}},getServiceByName:sinon.stub(),getYAMLConfig:sinon.stub(),linkify:sinon.stub(),service:{get:function(g){return'id'===g?'abc123':'series'===g?'trusty':'pending'!==g&&{option1:'string body value'}}},serviceRelations:[],setConfig:sinon.stub(),unplaceServiceUnits:sinon.stub(),updateServiceUnitsDisplayname:sinon.stub()}));assert.strictEqual(f.props.children[0].props.children[1],void 0)}),it('can handle changing of series',function(){var b={key:'option1key',type:'string'},e={get:function(k){return'id'===k?'abc123':'series'===k?'trusty':'pending'!==k&&{option1:'string body value'}},set:sinon.stub()},f=sinon.stub().returns([{},{}]),g=sinon.stub(),h=sinon.stub(),i=jsTestUtils.shallowRender(React.createElement(juju.components.Configuration,{acl:a,addNotification:g,changeState:h,charm:{get:function(k){return'options'===k?{option1:b}:'series'===k?['precise','trusty']:void 0}},getServiceByName:sinon.stub(),getYAMLConfig:sinon.stub(),linkify:sinon.stub(),service:e,serviceRelations:[],setConfig:sinon.stub(),unplaceServiceUnits:f,updateServiceUnitsDisplayname:sinon.stub()}),!0),j=i.getMountedInstance();j.refs={ServiceName:{getValue:sinon.stub()}},j._handleSeriesChange({currentTarget:{value:'xenial'}}),assert.equal(e.set.callCount,1),assert.deepEqual(e.set.args[0],['series','xenial']),assert.equal(f.callCount,1),assert.equal(f.args[0][0],'abc123'),assert.equal(g.callCount,1),assert.equal(h.callCount,1),assert.deepEqual(h.args[0][0],{gui:{machines:''}})}),it('stops setting changes if service name already exists',function(){var d={get:sinon.stub().returns({option1:{key:'option1key',type:'string'},option2:{key:'option2key',type:'boolean'}})},g=sinon.stub();g.withArgs('id').returns('abc123$'),g.withArgs('name').returns('servicename'),g.withArgs('config').returns({option1:'string body value',option2:!0});var h={get:g,set:sinon.stub()},i=sinon.stub(),j=sinon.stub().returns(!0),k=sinon.stub(),l=testUtils.renderIntoDocument(React.createElement(juju.components.Configuration,{acl:a,addNotification:k,changeState:sinon.stub(),charm:d,getServiceByName:j,getYAMLConfig:sinon.stub(),linkify:sinon.stub(),service:h,serviceRelations:[],setConfig:sinon.stub(),unplaceServiceUnits:sinon.stub(),updateServiceUnitsDisplayname:i})),m=ReactDOM.findDOMNode(l),n=m.querySelector('.string-config-input');n.innerText='newservicename',testUtils.Simulate.input(n);var o=m.querySelector('.button-row--count-2 .button--neutral');testUtils.Simulate.click(o),assert.equal(k.callCount,1),assert.equal(h.set.callCount,0),assert.equal(i.callCount,0)}),it('not able to change the service name on deployed services',function(){var d={get:sinon.stub().returns({option1:{key:'option1key',type:'string'},option2:{key:'option2key',type:'boolean'}})},g=sinon.stub();g.withArgs('id').returns('abc123'),g.withArgs('name').returns('servicename'),g.withArgs('config').returns({option1:'string body value',option2:!0});var h={get:g,set:sinon.stub()},i=testUtils.renderIntoDocument(React.createElement(juju.components.Configuration,{acl:a,addNotification:sinon.stub(),changeState:sinon.stub(),charm:d,getServiceByName:sinon.stub(),getYAMLConfig:sinon.stub(),linkify:sinon.stub(),service:h,serviceRelations:[],setConfig:sinon.stub(),unplaceServiceUnits:sinon.stub(),updateServiceUnitsDisplayname:sinon.stub()}));assert.equal(i.refs.ServiceName,void 0)}),it('can handle cancelling the changes',function(){var c={get:sinon.stub().returns('mysql')},d=sinon.stub();const e=jsTestUtils.shallowRender(React.createElement(juju.components.Configuration,{acl:a,addNotification:sinon.stub(),changeState:d,charm:{get:function(){return null}},getServiceByName:sinon.stub(),getYAMLConfig:sinon.stub(),linkify:sinon.stub(),service:c,serviceRelations:[],setConfig:sinon.stub(),unplaceServiceUnits:sinon.stub(),updateServiceUnitsDisplayname:sinon.stub()}),!0),f=e.getRenderOutput();f.props.children[1].props.children.props.buttons[0].action(),assert.equal(d.callCount,1),assert.deepEqual(d.args[0][0],{gui:{inspector:{id:'mysql',activeComponent:void 0}}})}),it('can open the file dialog when the button is clicked',function(){var c={get:sinon.stub().returns('mysql')},d=sinon.stub(),e=sinon.stub(),f=jsTestUtils.shallowRender(React.createElement(juju.components.Configuration,{acl:a,addNotification:sinon.stub(),changeState:e,charm:{get:function(){return null}},getServiceByName:sinon.stub(),getYAMLConfig:sinon.stub(),linkify:sinon.stub(),service:c,serviceRelations:[],setConfig:sinon.stub(),unplaceServiceUnits:sinon.stub(),updateServiceUnitsDisplayname:sinon.stub()}),!0),g=f.getMountedInstance();g.refs={file:{click:d}};var h=f.getRenderOutput(),i=h.props.children[0];i.props.children[3].props.children.props.buttons[0].action(),assert.equal(d.callCount,1)}),it('can get a YAML file when a file is selected',function(){var c={get:sinon.stub().returns('mysql')},d=sinon.stub(),e=sinon.stub(),f=sinon.stub(),g=jsTestUtils.shallowRender(React.createElement(juju.components.Configuration,{acl:a,addNotification:sinon.stub(),changeState:f,charm:{get:function(){return null}},getServiceByName:sinon.stub(),getYAMLConfig:d,linkify:sinon.stub(),service:c,serviceRelations:[],setConfig:sinon.stub(),unplaceServiceUnits:sinon.stub(),updateServiceUnitsDisplayname:sinon.stub()}),!0),h=g.getMountedInstance();h.refs={file:{files:['apache2.yaml']},'file-form':{reset:e},ServiceName:{getValue:sinon.stub()}};var i=g.getRenderOutput();i.props.children[0].props.children[2].props.children.props.onChange(),assert.equal(d.callCount,1),assert.equal(d.args[0][0],'apache2.yaml'),assert.equal(d.args[0][1],h._applyConfig),assert.equal(e.callCount,1)}),it('can apply the uploaded config',function(){const d=sinon.stub();d.onCall(0).returns('description 1'),d.onCall(1).returns('description 2'),d.onCall(2).returns('description 1'),d.onCall(3).returns('description 2'),d.onCall(4).returns('description 1'),d.onCall(5).returns('description 2');var g=sinon.stub();g.withArgs('name').returns('apache2'),g.withArgs('options').returns({option1:{key:'option1key',type:'string'},option2:{key:'option2key',type:'boolean'}});var h=sinon.stub();h.withArgs('id').returns('apache2'),h.withArgs('config').returns({option1:'string body value',option2:!0});var k=sinon.stub().callsArgWith(1,{apache2:{option1:'my apache2',option2:!1}}),l=sinon.stub(),m=jsTestUtils.shallowRender(React.createElement(juju.components.Configuration,{acl:a,addNotification:sinon.stub(),changeState:l,charm:{get:g},getServiceByName:sinon.stub(),getYAMLConfig:k,linkify:d,service:{get:h},serviceRelations:[],setConfig:sinon.stub(),unplaceServiceUnits:sinon.stub(),updateServiceUnitsDisplayname:sinon.stub()}),!0),n=m.getMountedInstance();n.refs={file:{files:['apache2.yaml']},'file-form':{reset:sinon.stub()},ServiceName:{getValue:sinon.stub()},'Config-option1':{getKey:sinon.stub().returns('option1'),getValue:sinon.stub().returns('')},'Config-option2':{getKey:sinon.stub().returns('option2'),getValue:sinon.stub().returns('')}};var o=m.getRenderOutput();o.props.children[0].props.children[2].props.children.props.onChange(),o=m.getRenderOutput(),expect(o.props.children[0].props.children[4][0]).toEqualJSX(React.createElement(juju.components.StringConfig,{key:'Config-option1',ref:'Config-option1',onChange:n._handleOnChange,option:{description:'description 1',key:'option1',type:'string'},config:'my apache2'})),expect(o.props.children[0].props.children[4][1]).toEqualJSX(React.createElement(juju.components.BooleanConfig,{key:'Config-option2',ref:'Config-option2',label:'option2:',onChange:n._handleOnChange,option:{description:'description 2',key:'option2',type:'boolean'},config:!1}))}),it('does not try to apply the config for the wrong charm',function(){var f=sinon.stub();f.withArgs('name').returns('apache2'),f.withArgs('options').returns({option1:{key:'option1key',type:'string'},option2:{key:'option2key',type:'boolean'}});var g=sinon.stub();g.withArgs('id').returns('apache2'),g.withArgs('config').returns({option1:'string body value',option2:!0});var j=sinon.stub().callsArgWith(1,{postgresql:{option1:'my apache2',option2:!1}}),k=sinon.stub(),l=jsTestUtils.shallowRender(React.createElement(juju.components.Configuration,{acl:a,addNotification:sinon.stub(),changeState:k,charm:{get:f},getServiceByName:sinon.stub(),getYAMLConfig:j,linkify:sinon.stub(),service:{get:g},serviceRelations:[],setConfig:sinon.stub(),unplaceServiceUnits:sinon.stub(),updateServiceUnitsDisplayname:sinon.stub()}),!0),m=l.getMountedInstance();m.refs={file:{files:['apache2.yaml']},'file-form':{reset:sinon.stub()},ServiceName:{getValue:sinon.stub()},'Config-option1':{getKey:sinon.stub().returns('option1'),getValue:sinon.stub().returns('')},'Config-option2':{getKey:sinon.stub().returns('option2'),getValue:sinon.stub().returns('')}};var n=l.getRenderOutput();assert.deepEqual(m.state.serviceConfig,{option1:'string body value',option2:!0}),n.props.children[0].props.children[2].props.children.props.onChange(),n=l.getRenderOutput(),assert.deepEqual(m.state.serviceConfig,{option1:'string body value',option2:!0})}),it('can disable controls when read only',function(){a.isReadOnly=sinon.stub().returns(!0);var b={key:'option1key',type:'string'},c={key:'option2key',type:'boolean'};const d=sinon.stub();d.onCall(0).returns('description 1'),d.onCall(1).returns('description 2');var e='string body value',f=!0,i=sinon.stub(),j=jsTestUtils.shallowRender(React.createElement(juju.components.Configuration,{acl:a,addNotification:sinon.stub(),changeState:sinon.stub(),charm:{get:function(){return{option1:b,option2:c}}},getServiceByName:sinon.stub(),getYAMLConfig:sinon.stub(),linkify:d,service:{get:function(p){if('id'===p)return'abc123$';return'name'===p?'abc123$':{option1:e,option2:f}}},serviceRelations:[],setConfig:i,unplaceServiceUnits:sinon.stub(),updateServiceUnitsDisplayname:sinon.stub()}),!0),k=j.getMountedInstance(),l=j.getRenderOutput(),m=[{disabled:!0,title:'Import config file',action:k._openFileDialog}],n=[{disabled:!0,title:'Cancel',type:'base',action:k._showInspectorIndex},{disabled:!0,title:'Save changes',type:'neutral',action:k._saveConfig}],o=React.createElement('div',{className:'inspector-config'},React.createElement('div',{className:'inspector-config__fields'},React.createElement(juju.components.StringConfig,{disabled:!0,ref:'ServiceName',onChange:k._handleOnChange,option:{key:'Application name',description:'Specify a custom application name. The application name cannot be changed once it has been deployed.'},config:'abc123$'}),void 0,React.createElement('form',{ref:'file-form'},React.createElement('input',{className:'hidden',disabled:!0,onChange:k._importConfig,ref:'file',type:'file'})),React.createElement('div',{className:'inspector-config__config-file'},React.createElement(juju.components.ButtonRow,{buttons:m})),[React.createElement(juju.components.StringConfig,{disabled:!0,key:'Config-option1',ref:'Config-option1',onChange:k._handleOnChange,option:{description:'description 1',key:'option1',type:'string'},config:e}),React.createElement(juju.components.BooleanConfig,{disabled:!0,key:'Config-option2',ref:'Config-option2',onChange:k._handleOnChange,option:{description:'description 2',key:'option2',type:'boolean'},label:'option2:',config:f})]),React.createElement('div',{className:'inspector-config__buttons inspector-config__buttons--hidden'},React.createElement(juju.components.ButtonRow,{buttons:n})));expect(l).toEqualJSX(o)})});