'use strict';describe('Bakery',()=>{let a,b,c,d,e;beforeAll((f)=>{c=require('js-macaroon'),f()}),beforeEach(()=>{b={store:{},getItem:function(f){return this.store[f]},setItem:function(f,g){this.store[f]=g},removeItem:function(f){delete this.store[f]}},e={_sendRequest:sinon.stub(),sendGetRequest:function(...f){this._sendRequest('get',...f)},sendPostRequest:function(...f){this._sendRequest('post',...f)},sendPutRequest:function(...f){this._sendRequest('put',...f)},sendDeleteRequest:function(...f){this._sendRequest('delete',...f)},sendPatchRequest:function(...f){this._sendRequest('patch',...f)}},d=new jujulib.BakeryStorage(b,{services:{charmstore:'http://example.com/charmstore',otherService:'http://example.com/other'}}),a=new jujulib.Bakery(e,d)}),afterEach(()=>{a=null,d=null}),describe('can send requests',()=>{it('sets the method',()=>{const f='http://example.com/',g={header:42},h=()=>42;let i='content',j;['PATCH','post','PUT'].forEach((k)=>{a.sendRequest(f,k,g,i,h),assert.equal(e._sendRequest.callCount,1),j=e._sendRequest.args[0],assert.equal(j[0],k.toLowerCase()),assert.equal(j[1],f),assert.deepEqual(j[2],{header:42,'Bakery-Protocol-Version':1}),assert.equal(j[3],i),assert.isFunction(j[8]),e._sendRequest.reset()}),['GET','delete'].forEach((k)=>{a.sendRequest(f,k,g,h),assert.equal(e._sendRequest.callCount,1),j=e._sendRequest.args[0],assert.equal(j[0],k.toLowerCase()),assert.equal(j[1],f),assert.deepEqual(j[2],{header:42,'Bakery-Protocol-Version':1}),assert.isFunction(j[7]),e._sendRequest.reset()})}),it('properly handles cookie auth',()=>{const f=e._sendRequest,g=(h,i,j)=>{f.reset(),a.sendRequest('http://example.com'+i,h),assert.strictEqual(f.args[0][6],j,`${h} ${i}`)};g('PUT','/set-auth-cookie',!0),g('PUT','/foo/set-auth-cookie/bar',!0),g('PUT','/',!1),g('PUT','/foo',!1),g('POST','/set-auth-cookie',!1),g('POST','/foo/set-auth-cookie/bar',!1),g('POST','/foo',!1)}),it('sets the headers',()=>{a.sendRequest('http://example.com/','GET',{foo:'bar'});assert.deepEqual(e._sendRequest.args[0][2],{'Bakery-Protocol-Version':1,foo:'bar'})}),it('adds macaroons to the request',()=>{b.store.charmstore='doctor',b.store.identity='bad wolf',a.sendRequest('http://example.com/charmstore','GET');assert.deepEqual(e._sendRequest.args[0][2],{'Bakery-Protocol-Version':1,Macaroons:'doctor'})}),it('wraps callbacks with discharge functionality',()=>{const f=sinon.stub(a,'_wrapCallback');a.sendRequest('http://example.com/','GET'),assert.equal(f.callCount,1)})}),describe('macaroon discharges',()=>{let f,g;beforeEach(()=>{f=sinon.stub(c,'dischargeMacaroon'),g=sinon.stub(c,'generateMacaroons')}),afterEach(()=>{f.restore(),g.restore()}),it('discharges macaroons',()=>{const h='this is a macaroon';a.discharge(h,(k)=>{assert.equal(k,h)},(k)=>{console.error(k),assert.fail()}),assert.equal(f.callCount,1,'macaroonlib discharge not called')}),it('handles failures discharging macaroons',()=>{const i={message:'bad wolf'};f.callsArgWith(2,'this is a macaroon'),g.throws(i);a.discharge('macaroons',()=>{},(l)=>{assert.equal(l,`discharge failed: ${i.message}`)})}),it('handles third party discharge',()=>{a._getThirdPartyDischarge('http://example.com/','http://example.com/identity','this is a caveat',()=>{},()=>{}),assert.equal(e._sendRequest.callCount,1);const k=e._sendRequest.args[0];assert.equal(k[0],'post'),assert.equal(k[1],'http://example.com/identity/discharge'),assert.deepEqual(k[2],{'Bakery-Protocol-Version':1,'Content-Type':'application/x-www-form-urlencoded'}),assert.equal(k[3],'id=this%20is%20a%20caveat&location=http%3A%2F%2Fexample.com%2F')})}),describe('wrapped callbacks',()=>{const f=(g)=>{if(!g)return{status:200};const h=JSON.stringify(g);return{status:401,getResponseHeader:sinon.stub().returns('application/json'),responseText:h}};it('handles requests normally if nothing is needed',()=>{const g=sinon.stub(),h=a._wrapCallback('http://example.com','POST',{},'body',g),i=f();h({target:i}),assert.equal(g.callCount,1)}),it('handles interaction if needed',()=>{const g=sinon.stub(a,'_interact'),h=sinon.stub(),i=a._wrapCallback('http://example.com','POST',{},'body',h),j=f({Code:'interaction required',Info:{VisitURL:'http://example.com/identity',WaitURL:'http://example.com/identity/wait'}});i({target:j}),assert.equal(g.callCount,1);const k=g.args[0][0].Info;assert.equal(k.VisitURL,'http://example.com/identity'),assert.equal(k.WaitURL,'http://example.com/identity/wait')}),it('handles discharge if needed',()=>{const g=sinon.stub(a,'discharge'),h=sinon.stub(),i=a._wrapCallback('http://example.com','POST',{},'body',h),j=f({Code:'macaroon discharge required',Info:{Macaroon:'macaroon'}});i({target:j}),assert.equal(g.callCount,1);const k=g.args[0];assert.equal(k[0],'macaroon')}),it('do not acquire macaroons if discharge is disabled',()=>{a=a.withoutDischarge();const g=sinon.stub(a,'discharge'),h=sinon.stub(),i=a._wrapCallback('http://example.com','POST',{},'body',h),j=f({Code:'macaroon discharge required',Info:{Macaroon:'macaroon'}});i({target:j}),assert.equal(g.callCount,0,'discharge call count'),assert.equal(h.callCount,1,'callback call count');const k=h.args[0];assert.equal(k.length,2,'callback args'),assert.strictEqual(k[0],'discharge required but disabled'),assert.deepEqual(k[1].target,j)})}),describe('interact handling',()=>{const f=(g)=>{let h={target:{status:200,responseText:'',response:''}};return g&&(h.target.status=0),h};it('accepts a visit page method',()=>{a=new jujulib.Bakery(e,d,{visitPage:()=>{return'visits'}}),assert.equal(a._visitPage(),'visits')}),it('opens the visit page',()=>{const g=sinon.stub(window,'open'),h={Info:{VisitURL:'http://example.com'}};a._visitPage(h),assert.equal(g.callCount,1),assert.equal(g.args[0][0],h.Info.VisitURL),g.restore()}),it('sets the content type correctly for the wait call',()=>{a._interact({Info:{WaitURL:'http://example.com/wait',VisitURL:'http://example.com/visit'}},()=>{},()=>{}),assert.equal(e._sendRequest.callCount,1),assert.equal(e._sendRequest.args[0][1],'http://example.com/wait'),assert.equal(e._sendRequest.args[0][2]['Content-Type'],'application/json')}),it('handles retry',()=>{e._sendRequest.onFirstCall().callsArgWith(7,f(!0)).onSecondCall().callsArgWith(7,f(!1)),a._interact({Info:{WaitURL:'http://example.com/wait',VisitURL:'http://example.com/visit'}},()=>{},()=>{}),assert.equal(e._sendRequest.callCount,2)}),it('limits retries',()=>{e._sendRequest.callsArgWith(7,f(!0)),a._interact({Info:{WaitURL:'http://example.com/wait',VisitURL:'http://example.com/visit'}},()=>{},()=>{}),assert.equal(e._sendRequest.callCount,6)}),it('handles errors',()=>{e._sendRequest.callsArgWith(7,f(!0)),sinon.stub(a,'_getError').returns({message:'bad wolf'});const h=sinon.stub(),i=sinon.stub();a._interact({Info:{WaitURL:'http://example.com/wait',VisitURL:'http://example.com/visit'}},h,i),assert.equal(h.callCount,0),assert.equal(i.callCount,1),assert.equal(i.args[0][0],'cannot interact: bad wolf')}),it('handles success',()=>{e._sendRequest.callsArgWith(7,f(!0)),sinon.stub(a,'_getError').returns(null);const h=sinon.stub(),i=sinon.stub();a._interact({Info:{WaitURL:'http://example.com/wait',VisitURL:'http://example.com/visit'}},h,i),assert.equal(h.callCount,1),assert.equal(i.callCount,0)})}),describe('storage',()=>{it('sets items',()=>{d.set('http://example.com/charmstore','foo',()=>{}),assert.equal(b.store.charmstore,'foo')}),it('gets items',()=>{b.store.charmstore='foo',assert.equal('foo',d.get('http://example.com/charmstore'))}),it('sets cookies for charmstore',()=>{const f=sinon.stub();d=new jujulib.BakeryStorage(b,{services:{charmstore:'http://example.com/charmstore'},charmstoreCookieSetter:f});const h=btoa(JSON.stringify('macaroon'));d.set('http://example.com/charmstore',h,()=>{}),assert.equal(f.callCount,1),assert.equal(f.args[0][0],'macaroon')}),describe('keys',()=>{it('special cases identity',()=>{Object.keys(d._services).forEach((f)=>{assert.notEqual('identity',f)}),assert.equal('identity',d._getKey('http://example.com/identity/'))}),it('gets keys from services',()=>{assert.equal('charmstore',d._getKey('http://example.com/charmstore'))})})})});